set more off
* cd C:\Dropbox\Rshock\STATA_Workplace
 cd U:\tf\Matteo\Rshock\STATA_Workplace
use PANEL_DATASET, clear
adopath ++ .\ADOFILES
xtset country quarter
set scheme s1color



replace US_r = FFED

gen US_t = 0
gen d1_r = US_r-L1.US_r
gen d2_r = US_r-L2.US_r
gen d3_r = US_r-L3.US_r
gen d4_r = US_r-L4.US_r
gen f1_r = F1.US_r-US_r
gen f2_r = F2.US_r-US_r
gen f3_r = F3.US_r-US_r
gen f4_r = F4.US_r-US_r

replace US_t = US_r if d1_r>0 & d2_r>0.2  & d3_r>0.4  & tin(1965q1,2016q4)
replace US_t = US_r if d1_r>-0.3 & d2_r>-0.2 & d3_r>-0.1 & f1_r>-0.1 & f2_r>0.2 & f3_r>0.3 & tin(1965q1,2016q4)
replace US_t = US_r if d1_r>-0.3 & d2_r>-0.2 & d3_r>-0.1 & f1_r>-0.1 & f2_r>0.2 & f3_r>0.3 & tin(1965q1,2016q4)
replace US_t = US_r if f2_r>2 & f3_r>3.5
replace US_t = US_r if d3_r>1 & d4_r>2 & f2_r>1 & f3_r>0
//replace US_t = 0 if L1.US_t==0 & (F1.US_r - US_r<0)
//replace US_t = 0 if L1.US_t==0 & (F2.US_r - US_r<0)
//replace US_t = 0 if L1.US_t==0 & (F3.US_r - US_r<0)
replace US_t = 0 if L1.US_t==.

*browse quarter US_t US_r d1_r d2_r d3_r d4_r f1_r f2_r f3_r if countrylong=="United States"



* Define tightening cycle as period in which US_t=US_r





datesof quarter if US_t==US_r

local t_ep = r(date_list)
di r(date_list)



gen US_tm = .
replace US_tm = US_t if US_t>0




gen rtaylor = 4 + 1.5*(US_dp-2) - (US_u-5)


 di r(date_list)

 
 
 
label var US_r "Fed Funds Rate"
label var US_tm "Monetary Tightening Episodes"

datesof quarter if US_t == US_r
local t_ep = r(date_list)
local c = 1
local str1a = "function y=20,range("
local str1b = "function y=1,range("
local str1c = "function y=6,range("
local str2a = ") recast(area) color(olive_teal) base(0) "
local str2b = ") recast(area) color(olive_teal) base(-1) "
local str2c = ") recast(area) color(olive_teal) base(0) "
local strc1 = ""
local strc2 = ""
local strc3 = ""

foreach ep of local t_ep{
			local qmax		= wordcount("`t_ep'")
			local t1 = substr("`ep'",2,6)
			local t2 = substr("`ep'",-7,6)
			local t1 = tq(`t1')
			local t2 = tq(`t2')
			local strc1 = "`strc1'" + "`str1a'" + "`t1' " + "`t2'" + "`str2a'"
			local strc2 = "`strc2'" + "`str1b'" + "`t1' " + "`t2'" + "`str2b'"
			local strc3 = "`strc3'" + "`str1c'" + "`t1' " + "`t2'" + "`str2c'"
			if `c' != `qmax' local strc1 = "`strc1' || "
			if `c' != `qmax' local strc2 = "`strc2' || "
			if `c' != `qmax' local strc3 = "`strc3' || "
		 }
local ++qmax



#delim ;
graph twoway `strc1' || 
tsline US_r if countrylong=="United States" & tin(1965q1,2016q4), 
xlabel(,format(%tq) tp(i)) 
lstyle(p4 p) 
lwidth(1 1) 
ylabel(,tp(i))
tlabel(1965q1(40)2016q4)
legend(off)
name(RU, replace) ;
#delim cr



gr export US_interest_rates.pdf, mag(100) replace

 


 
replace US_t=0 if tin(1965q1,1977q4) 
replace US_t=0 if tin(2016q2,2016q3)
datesof quarter if US_t==US_r
local t_ep = r(date_list)
di r(date_list) 

 


*merge 1:1 country quarter using demanddec, nogen
*merge 1:1 country quarter using monetarydec, nogen



drop if nobs_gdp<120



gen ln_gdp_forecast = .
gen ln_gdp_arima = .
gen sumyhat = .
unab pre_loop_vars : _all
gen DGDPS = .
gen DGDPA = .
gen DGDPF = .





local cc = 5

* UNCOMMENT NEXT TWO LINES TO SELECT EPISODE cc=1, 2 and 3 FROM LIST
local cc = 1
local t_ep : word `cc' of `t_ep'


 
 

foreach ep of local t_ep {
			
	
			keep `pre_loop_vars'
			
			local t1 = substr("`ep'",2,6)
			local t2 = substr("`ep'",-7,6)

			local t1 = tq(`t1')
			local t2 = tq(`t2')

			local t1p = `t1'+1
			local t2p = `t2'+4

		    local horizon = `t2p'-`t1'
		

			di "var:`i' date:`t1'_`t2'"

			
		    
			**********************************************************************
			*** START FORECAST IN PERIOD OF MONETARY SHOCK, USE ALL AVAILABLE INFO
			**********************************************************************
			* See discussion of dyn option here
			* http://www.stata.com/manuals13/tsarchpostestimation.pdf
			sort country quarter
			levelsof country, local(groups)			
			foreach a of local groups {
			quietly capture arima ln_gdp L(1/4).ln_gdp trend if country==`a' 
			predict yhat if country==`a', dyn(`t1p')
			replace ln_gdp_arima = yhat if country==`a'
			capture drop yhat
			}
			
	
	
			
			
     		gen GDPA 		= ln_gdp if quarter>=`t1' & quarter<=`t2p'
     		gen GDPF 		= ln_gdp_arima if quarter>=`t1' & quarter<=`t2p'
			*replace GDPF   = ln_gdp if quarter==`t1'
				
			*-------------------------------------------------	
			* First measure: GROWTH LOST compare endpoints	{ USED FOR NOW ]	
			*-------------------------------------------------	
			* This is GDP at time 0 and time 1	
			egen mGDPA0_ 	= mean(GDPA) if quarter==`t1p', by(country)
			egen mGDPA1_ 	= mean(GDPA) if quarter==`t2p', by(country)
			egen mGDPA0 = mean(mGDPA0_), by(country)
			egen mGDPA1 = mean(mGDPA1_), by(country)
			gen DGDPA = (mGDPA1-mGDPA0)/`horizon'*4

			egen mGDPF0_ 	= mean(GDPF) if quarter==`t1p', by(country)
			egen mGDPF1_ 	= mean(GDPF) if quarter==`t2p', by(country)
			egen mGDPF0 = mean(mGDPF0_), by(country)
			egen mGDPF1 = mean(mGDPF1_), by(country)
			gen DGDPF = (mGDPF1-mGDPF0)/`horizon'*4

			gen DGDPS1 =  DGDPA - DGDPF

			
			
			*-------------------------------------------------	
			* Second measure: GDP level LOST, look at the whole GDP path
			*-------------------------------------------------	
			* An alternative measure looks at the GDP losses, and converts them in growth shortfall
			* Take average quarterly GDP in the two scenarios
			* In one, GDPF is 100 100 100 100  
			* In other GDPA is 100 100 99 100
			* Output losses are 0.25% ON ANNUALIZED BASIS
			egen mGDPAa 	= mean(GDPA) if quarter>=`t1p' & quarter<=`t2p', by(country)
			egen mGDPFa 	= mean(GDPF) if quarter>=`t1p' & quarter<=`t2p', by(country)
	
			gen DGDPS2 = 100*(exp(mGDPAa/100)/exp(mGDPFa/100)-1)/`horizon'*4
			
			
						
			di `horizon'
			
	 
			
			
			gen DGDPS = DGDPS1
			local varlabel 	= "GDP Growth Relative to Forecast"	
			local varlabel 	= " "	
			
			*gen DGDPS = DGDPS2
			*local varlabel 	= "GDP Level Relative to Forecast, Annualized"	
			
			/*
			gen histdectot = histdecm`cc' + histdecy`cc'			
			gen histdecm = histdecm`cc'			
			gen histdecy = histdecy`cc' 			
     		
	        gen histdectot_e = histdectot/`horizon'*4 if quarter==`t2p'				
			gen histdecm_e = histdecm/`horizon'*4 if quarter==`t2p'				
			gen histdecy_e = histdecy/`horizon'*4 if quarter==`t2p'				
			
			egen mhistdectot 	= mean(histdectot_e), by(country)
			egen mhistdecm 	= mean(histdecm_e), by(country)			
			egen mhistdecy 	= mean(histdecy_e), by(country)
			
			gen mhistdectot_afe	= mhistdectot if dum_afe == 1
			gen mhistdectot_eme	= mhistdectot if dum_eme == 1
			gen mhistdectot_us 	= mhistdectot if dum_us == 1
			gen mhistdectot_for = mhistdectot if dum_afe != 1 & dum_us != 1 & dum_eme != 1
			
			gen mhistdecm_afe	= mhistdecm if dum_afe == 1
			gen mhistdecm_eme	= mhistdecm if dum_eme == 1
			gen mhistdecm_us 	= mhistdecm if dum_us == 1
			gen mhistdecm_for 	= mhistdecm if dum_afe != 1 & dum_us != 1 & dum_eme != 1
			
			gen mhistdecy_afe	= mhistdecy if dum_afe == 1
			gen mhistdecy_eme	= mhistdecy if dum_eme == 1
			gen mhistdecy_us 	= mhistdecy if dum_us == 1
			gen mhistdecy_for 	= mhistdecy if dum_afe != 1 & dum_us != 1 & dum_eme != 1
			
			label var mhistdecm_afe "US Monetary, AFE"
			label var mhistdecm_eme "US Monetary, EME"
			label var mhistdecy_afe "US Demand, AFE"
			label var mhistdecy_eme "US Demand, EME"
			*/
			
			egen mgdps 		= mean(DGDPS), by(country)
			gen gdps_afe	= mgdps if dum_afe == 1
			gen gdps_eme	= mgdps if dum_eme == 1
			gen gdps_us 	= mgdps if dum_us == 1
			gen gdps_for 	= mgdps if dum_afe != 1 & dum_us != 1 & dum_eme != 1
			

			
			
			gen dum_sa = 0
			replace dum_sa = 1 if countrylong=="Venezuela" 
			replace dum_sa = 1 if countrylong=="Chile" 
			replace dum_sa = 1 if countrylong=="Ecuador" 
			replace dum_sa = 1 if countrylong=="Argentina" 
			replace dum_sa = 1 if countrylong=="Colombia" 
			replace dum_sa = 1 if countrylong=="El Salvador" 
			replace dum_sa = 1 if countrylong=="Peru" 
			
			gen dum_othereme = 0
			replace dum_othereme = 1 if countrylong=="Israel" 
			replace dum_othereme = 1 if countrylong=="Jordan" 
			replace dum_othereme = 1 if countrylong=="Botswana" 
			replace dum_othereme = 1 if countrylong=="South Africa" 
			replace dum_othereme = 1 if countrylong=="Turkey" 

			gen dum_asiaexchina = 0
			replace dum_asiaexchina = 1 if countrylong=="Singapore"
			replace dum_asiaexchina = 1 if countrylong=="Hong Kong"
			replace dum_asiaexchina = 1 if countrylong=="Korea"
			replace dum_asiaexchina = 1 if countrylong=="Taiwan"
			replace dum_asiaexchina = 1 if countrylong=="Indonesia"
			replace dum_asiaexchina = 1 if countrylong=="Malaysia"
			replace dum_asiaexchina = 1 if countrylong=="Philippines"
			replace dum_asiaexchina = 1 if countrylong=="Thailand"
			replace dum_asiaexchina = 1 if countrylong=="India"
								
			gen dum_otherafe = 0
			replace dum_otherafe = 1 if countrylong=="Australia" 
			replace dum_otherafe = 1 if countrylong=="New Zealand" 
			
			gen dum_europe = 0
			replace dum_europe = 1 if countrylong=="Ireland" 
			replace dum_europe = 1 if countrylong=="Greece" 
			replace dum_europe = 1 if countrylong=="Finland" 
			replace dum_europe = 1 if countrylong=="Luxembourg" 
			replace dum_europe = 1 if countrylong=="Iceland" 
			replace dum_europe = 1 if countrylong=="Denmark" 
			replace dum_europe = 1 if countrylong=="Netherlands" 
			replace dum_europe = 1 if countrylong=="Austria" 
			replace dum_europe = 1 if countrylong=="Italy" 
			replace dum_europe = 1 if countrylong=="France" 
			replace dum_europe = 1 if countrylong=="Spain" 
			replace dum_europe = 1 if countrylong=="Germany" 
			replace dum_europe = 1 if countrylong=="Sweden" 
			replace dum_europe = 1 if countrylong=="Norway" 
			replace dum_europe = 1 if countrylong=="Portugal" 
			replace dum_europe = 1 if countrylong=="Switzerland" 
*			replace dum_europe = 1 if countrylong=="United Kingdom" 
			replace dum_europe = 1 if countrylong=="Belgium" 
						
	
			egen gdps_sa 			= mean(mgdps) if dum_sa == 1, by(quarter)
			egen gdps_othereme 		= mean(mgdps) if dum_othereme == 1, by(quarter)
			egen gdps_asiaexchina 	= mean(mgdps) if dum_asiaexchina == 1, by(quarter)
			egen gdps_otherafe 		= mean(mgdps) if dum_otherafe == 1, by(quarter)
			egen gdps_europe 		= mean(mgdps) if dum_europe == 1, by(quarter)
			
			/*
			local varlist1 = "mhistdectot mhistdecm mhistdecy"
			foreach v of local varlist1{
				egen `v'_sa 			= mean(`v') if dum_sa == 1, by(quarter)
				egen `v'_othereme 		= mean(`v') if dum_othereme == 1, by(quarter)
				egen `v'_asiaexchina 	= mean(`v') if dum_asiaexchina == 1, by(quarter)
				egen `v'_otherafe 		= mean(`v') if dum_otherafe == 1, by(quarter)
				egen `v'_europe 		= mean(`v') if dum_europe == 1, by(quarter)
			}	
			* Replace mhistdectot mhistdecm mhistdecy the way I do for mgdps
			*/
			

			local lt1 = substr("`ep'",2,6)
			local lt2 = substr("`ep'",-7,6)

			gen minusmgdps = -mgdps 
			
			
			preserve
			drop if dum_sa==1 & countrylong!="Peru"		
			drop if dum_othereme==1 & countrylong!="Israel"			
			drop if dum_asiaexchina==1 & countrylong!="Singapore"			
			drop if dum_otherafe==1 & countrylong!="Australia"			
			drop if dum_europe==1 & countrylong!="Belgium"			
 
			replace minusmgdps = -gdps_sa if countrylong=="Peru"
			replace minusmgdps = -gdps_othereme if countrylong=="Israel"
			replace minusmgdps = -gdps_asiaexchina if countrylong=="Singapore"
			replace minusmgdps = -gdps_otherafe if countrylong=="Australia"
			replace minusmgdps = -gdps_europe if countrylong=="Belgium"
			
			
			replace gdps_eme=. if countrylong=="Peru"
			replace gdps_eme=. if countrylong=="Israel"
			replace gdps_eme=. if countrylong=="Singapore"
			replace gdps_afe=. if countrylong=="Australia"
			replace gdps_afe=. if countrylong=="Belgium"

			/*
			local varlist2 = "mhistdectot mhistdecm mhistdecy"
			foreach v of local varlist2{
			
			replace `v'_eme=. if countrylong=="Peru"
			replace `v'_eme=. if countrylong=="Israel"
			replace `v'_eme=. if countrylong=="Singapore"
			replace `v'_afe=. if countrylong=="Australia"
			replace `v'_afe=. if countrylong=="Belgium"
			
			gen minus`v' = - `v'
			replace minus`v' = -`v'_sa if countrylong=="Peru"
			replace minus`v' = -`v'_othereme if countrylong=="Israel"
			replace minus`v' = -`v'_asiaexchina if countrylong=="Singapore"
			replace minus`v' = -`v'_otherafe if countrylong=="Australia"
			replace minus`v' = -`v'_europe if countrylong=="Belgium" 
			
			}
			*/
			
			replace countrylong="Oth.Lat.Am." if countrylong=="Peru"
			replace countrylong="M.East & Africa" if countrylong=="Israel"			
			replace countrylong="Asia ex China" if countrylong=="Singapore"			
			replace countrylong="Oceania" if countrylong=="Australia"			
			replace countrylong="Europe ex U.K." if countrylong=="Belgium"
			replace countrylong="U.K." if countrylong=="United Kingdom"
			replace countrylong="U.S.A." if countrylong=="United States"


			
			list countrylong minusmgdps gdps_us gdps_afe gdps_otherafe gdps_europe gdps_eme gdps_othereme gdps_sa gdps_asiaexchina  if tin(1980q1,1980q1)

			*saveold bardata`lt1' , replace
			gen plusmgdps = -minusmgdps 
			export excel countrylong plusmgdps using "bardata`lt1'.xlsx" if tin(1980q1,1980q1), firstrow(variables) replace
			export excel countrylong plusmgdps using "bardata.xlsx" if tin(1980q1,1980q1), firstrow(variables) sheet(`lt1', replace) 
			
			
			#delimit ;
			graph hbar gdps_us gdps_afe gdps_otherafe gdps_europe gdps_eme gdps_othereme gdps_sa gdps_asiaexchina 
			if quarter==`t1' & (mgdps!=.),  
			stack
			over(countrylong, sort(minusmgdps) label(nolabels) ) 
			bar(1, color(black))
			bar(2, color(blue))
			bar(3, color(blue))
			bar(4, color(blue))
			bar(5, color(red))
			bar(6, color(red))
			bar(7, color(red))
			bar(8, color(red))
			ysc(r(-7.9, 6.6)) 
			ylabel(-6(2)6) 
			legend(off)
			note(, size(vsmall))
			title("{bf:`cc'. `varlabel' `lt1' - `lt2' Tightening}", size(*.84))   
			blabel(group, size(medsmall)) 
			name(B`imodel'_`lt1', replace)  ;
			#delimit cr
			gr export figures\E5_`lt1'.pdf, mag(100) replace
			
			/*
			
			#delimit ;
			graph hbar mhistdectot_us mhistdectot_afe mhistdectot_otherafe mhistdectot_europe mhistdectot_eme mhistdectot_othereme mhistdectot_sa mhistdectot_asiaexchina 
			if quarter==`t1' & (mhistdectot!=. & mhistdectot!=0),  
			stack
			over(countrylong, sort(minusmgdps) label(nolabels) ) 
			bar(1, color(black))
			bar(2, color(blue))
			bar(3, color(blue))
			bar(4, color(blue))
			bar(5, color(red))
			bar(6, color(red))
			bar(7, color(red))
			bar(8, color(red))
			ysc(r(-6.6, 6.6)) 
			ylabel(-6(2)6) 
			legend(off)
			note(, size(vsmall))
			title("`cc'. US Factors in `lt1' - `lt2'", size(medlarge))   
			blabel(group, size(medsmall)) 
			name(US`lt1', replace);
			#delimit cr
			gr export figures\USHIST`lt1'.pdf, mag(100) replace

			
			label var mhistdecm_afe "US Monetary, AFE"
			label var mhistdecm_eme "US Monetary, EME"
			label var mhistdecy_afe "US Demand, AFE"
			label var mhistdecy_eme "US Demand, EME"
			
			
			
			
			#delimit ;

			graph hbar 
			mhistdecm_us mhistdecm_afe mhistdecm_otherafe mhistdecm_europe mhistdecm_eme mhistdecm_othereme mhistdecm_sa mhistdecm_asiaexchina 
			mhistdecy_us mhistdecy_afe mhistdecy_otherafe mhistdecy_europe mhistdecy_eme mhistdecy_othereme mhistdecy_sa mhistdecy_asiaexchina 
			if quarter==`t1' & (mhistdectot!=. & mhistdectot!=0),  
			stack
			over(countrylong, sort(minusmgdps) label(nolabels) ) 
			bar(1, color(yellow))
			bar(2, color(yellow))
			bar(3, color(yellow))
			bar(4, color(yellow))
			bar(5, color(yellow))
			bar(6, color(yellow))
			bar(7, color(yellow))
			bar(8, color(yellow))
			bar(9, color(green))
			bar(10, color(green))
			bar(11, color(green))
			bar(12, color(green))
			bar(13, color(green))
			bar(14, color(green))
			bar(15, color(green))
			bar(16, color(green))
			ysc(r(-6.6, 6.6)) 
			ylabel(-6(2)6) 
			legend(off)
			note(, size(vsmall))
			title("`cc'. US D Factors in `lt1' - `lt2'", size(medlarge))   
			blabel(group, size(medsmall) position(hbar)) 
			name(USD`lt1', replace);
			#delimit cr
			gr export figures\USHISTD`lt1'.pdf, mag(100) replace
			gr save figures\USHISTD`lt1'.gph, replace
						
			*/
			

			restore
			
			
			local ++cc

			*browse countrylong quarter mhistdecm_afe mhistdecm_eme mhistdecy_afe mhistdecy_eme if quarter==`t1',  
			preserve
			keep if quarter==`t1' 
			saveold tempfile, replace
			restore


			*xtline ln_gdp ln_gdp_arima if dum_eme==1 & tin(1990q1,2001q4), ylabel(, labsize(small)) tline(`t1') tline(`t2') byopts(rescale) name(TA`imodel'_`lt1', replace)
			
			preserve
			local nt1 = `t1'-12
			local nt2 = `t2p'+12

			
			egen ln_gdp100  = mean(ln_gdp) if quarter ==`t1',by(country quarter)
			egen ln_gdp_arima100  = mean(ln_gdp_arima) if quarter ==`t1',by(country quarter)
			
			egen _ln_gdp100  = mean(ln_gdp100) ,by(country)
			egen _ln_gdp_arima100  = mean(ln_gdp_arima100) ,by(country)
			
			replace ln_gdp100 = ln_gdp - _ln_gdp100 
			replace ln_gdp_arima100 = ln_gdp_arima - _ln_gdp_arima100 
			
			gen gdp100 = 100*exp(ln_gdp100/100)
			gen gdp_arima100 = 100*exp(ln_gdp_arima100/100)
			
			label var gdp100 "GDP"
			label var gdp_arima100 "Forecast"
			
			drop _ln_gdp100 _ln_gdp_arima100 
			
			
			# delimit  ;
			
			keep if 
			countrylong=="Canada" | countrylong=="Korea" | countrylong=="Mexico" | countrylong=="Brazil" | 
			countrylong=="United States" | countrylong=="Germany" | countrylong=="United Kingdom" | countrylong=="China" | countrylong=="Indonesia" |
			countrylong=="Turkey" | countrylong=="Argentina" | countrylong=="Taiwan" ;
			xtline gdp100 gdp_arima100 
			if (quarter>=`nt1' & quarter <=`nt2'), 
			xlabel(, labsize(vsmall)) ylabel(, labsize(vsmall)) tline(`t1') tline(`t2', lcolor(gs13)) tline(`t2p') ttitle("") byopts( note("") )
			byopts(rescale) name(L`imodel'_`lt1', replace) ;
			gr export figures\L`imodel'_`lt1'.pdf, mag(100) replace ;

			
	
			
			# delimit cr 
			
			keep quarter country gdp_arima100 gdp100 GDPA GDPF mGDPAa mGDPFa DGDPS1 DGDPS2
			saveold tempfilexxx`lt1', replace
			
		   restore


	

}



//replace US_t=0 if tin(1980q4,1981q2) 
//replace US_t=0 if tin(1983q3,1984q3) 
//replace US_t=0 if tin(1987q2,1989q2) 
//replace US_t=0 if tin(1994q1,1995q2) 
//replace US_t=0 if tin(1999q3,2000q3) 
//replace US_t=0 if tin(2004q3,2006q3) 

//(1978q1,1981q2) (1983q3,1984q3) (1987q2,1989q2)
//(1993q4,1995q2) (1999q3,2000q3) (2004q2,2006q3)


gr combine B_1978q1 B_1983q3 B_1987q2 B_1993q4 B_1999q3 B_2004q2, rows(3) xsize(5) ysize(6)
gr export motivation_six.pdf, mag(100) replace 
gr export C:\Dropbox\Rshock\Draft\v3\Figures\motivation_six.pdf, mag(100) replace 

